;;; File:     demo.clp
;;; Purpose:  Report-writing demo loader (Windows only).
;;;           For use with the demo BSDM diagram type
;;; Author:   Julian Smart
;;; Created:  16/7/94

(load "..\\utils\\utils1.clp")
(load "latex.clp")
(load "ddeword.clp")
(load "report.clp")

(deffunction test-event-handler (?card-id ?option)
  (switch ?option
   (case "Generate Word report" then
     (print-report-rtf ?card-id)
   )
   (case "Generate WinHelp report" then
     (print-report-winhelp ?card-id)
   )
  )  
)

; We are interested in CustomMenu events for BSDM demo diagram type
(register-event-handler CustomMenu "bsdm" test-event-handler)

; Turn off excessive output to the developer window
(unwatch all)
